primaryboolean | IResolvableprimarytyping.Union[bool, IResolvable]primaryBooleanPrimaryboolPrimaryinterface{}#Represents an attribute (column) in a data table.
Attributes define the schema and validation rules for values that can be stored in the table. They specify the data type, constraints, and whether the attribute is used as a primary key for record identification.
AWS::Connect::DataTableAttribute// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_connect as connect } from 'aws-cdk-lib';
const cfnDataTableAttribute = new connect.CfnDataTableAttribute(this, 'MyCfnDataTableAttribute', {
dataTableArn: 'dataTableArn',
instanceArn: 'instanceArn',
name: 'name',
valueType: 'valueType',
// the properties below are optional
description: 'description',
primary: false,
validation: {
enum: {
strict: false,
values: ['values'],
},
exclusiveMaximum: 123,
exclusiveMinimum: 123,
maximum: 123,
maxLength: 123,
maxValues: 123,
minimum: 123,
minLength: 123,
minValues: 123,
multipleOf: 123,
},
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_connect as connect
cfn_data_table_attribute = connect.CfnDataTableAttribute(self, "MyCfnDataTableAttribute",
data_table_arn="dataTableArn",
instance_arn="instanceArn",
name="name",
value_type="valueType",
# the properties below are optional
description="description",
primary=False,
validation=connect.CfnDataTableAttribute.ValidationProperty(
enum=connect.CfnDataTableAttribute.EnumProperty(
strict=False,
values=["values"]
),
exclusive_maximum=123,
exclusive_minimum=123,
maximum=123,
max_length=123,
max_values=123,
minimum=123,
min_length=123,
min_values=123,
multiple_of=123
)
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.connect.*;
CfnDataTableAttribute cfnDataTableAttribute = CfnDataTableAttribute.Builder.create(this, "MyCfnDataTableAttribute")
.dataTableArn("dataTableArn")
.instanceArn("instanceArn")
.name("name")
.valueType("valueType")
// the properties below are optional
.description("description")
.primary(false)
.validation(ValidationProperty.builder()
.enum(EnumProperty.builder()
.strict(false)
.values(List.of("values"))
.build())
.exclusiveMaximum(123)
.exclusiveMinimum(123)
.maximum(123)
.maxLength(123)
.maxValues(123)
.minimum(123)
.minLength(123)
.minValues(123)
.multipleOf(123)
.build())
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.Connect;
var cfnDataTableAttribute = new CfnDataTableAttribute(this, "MyCfnDataTableAttribute", new CfnDataTableAttributeProps {
DataTableArn = "dataTableArn",
InstanceArn = "instanceArn",
Name = "name",
ValueType = "valueType",
// the properties below are optional
Description = "description",
Primary = false,
Validation = new ValidationProperty {
Enum = new EnumProperty {
Strict = false,
Values = new [] { "values" }
},
ExclusiveMaximum = 123,
ExclusiveMinimum = 123,
Maximum = 123,
MaxLength = 123,
MaxValues = 123,
Minimum = 123,
MinLength = 123,
MinValues = 123,
MultipleOf = 123
}
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnDataTableAttribute := awscdk.Aws_connect.NewCfnDataTableAttribute(this, jsii.String("MyCfnDataTableAttribute"), &CfnDataTableAttributeProps{
DataTableArn: jsii.String("dataTableArn"),
InstanceArn: jsii.String("instanceArn"),
Name: jsii.String("name"),
ValueType: jsii.String("valueType"),
// the properties below are optional
Description: jsii.String("description"),
Primary: jsii.Boolean(false),
Validation: &ValidationProperty{
Enum: &EnumProperty{
Strict: jsii.Boolean(false),
Values: []*string{
jsii.String("values"),
},
},
ExclusiveMaximum: jsii.Number(123),
ExclusiveMinimum: jsii.Number(123),
Maximum: jsii.Number(123),
MaxLength: jsii.Number(123),
MaxValues: jsii.Number(123),
Minimum: jsii.Number(123),
MinLength: jsii.Number(123),
MinValues: jsii.Number(123),
MultipleOf: jsii.Number(123),
},
})
new CfnDataTableAttribute(scope: Construct, id: string, props: CfnDataTableAttributeProps)
CfnDataTableAttribute(scope: Construct, id: str, props: CfnDataTableAttributeProps)
new CfnDataTableAttribute(Construct scope, String id, CfnDataTableAttributeProps props)
new CfnDataTableAttribute(Construct scope, string id, CfnDataTableAttributeProps props)
NewCfnDataTableAttribute(Scope Construct, Id *string, Props CfnDataTableAttributeProps)
Must be unique within the data table and conform to Connect naming standards.
primaryboolean | IResolvableprimarytyping.Union[bool, IResolvable]primaryBooleanPrimaryboolPrimaryinterface{}#Primary attributes must have unique value combinations and cannot contain expressions.
validationIResolvable | CfnDataTableAttribute.ValidationPropertyvalidationtyping.Union[IResolvable, ValidationProperty]validationIResolvableValidationIResolvableValidationinterface{}#Based on JSON Schema Draft 2020-12 with additional Connect-specific validations for data integrity.
Must be one of TEXT, TEXT_LIST, NUMBER, NUMBER_LIST, or BOOLEAN. Determines how values are validated and processed.
attrAttributeIdstringattr_attribute_idstrattrAttributeIdStringAttrAttributeIdstringAttrAttributeId*stringrequired#attrLastModifiedRegionstringattr_last_modified_regionstrattrLastModifiedRegionStringAttrLastModifiedRegionstringAttrLastModifiedRegion*stringrequired#attrLastModifiedTimeIResolvableattr_last_modified_timeIResolvableattrLastModifiedTimeIResolvableAttrLastModifiedTimeIResolvableAttrLastModifiedTimeIResolvablerequired#attrLockVersionIResolvableattr_lock_versionIResolvableattrLockVersionIResolvableAttrLockVersionIResolvableAttrLockVersionIResolvablerequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#dataTableAttributeRefDataTableAttributeReferencedata_table_attribute_refDataTableAttributeReferencedataTableAttributeRefDataTableAttributeReferenceDataTableAttributeRefDataTableAttributeReferenceDataTableAttributeRefDataTableAttributeReferencerequired#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
primaryboolean | IResolvableprimarytyping.Union[bool, IResolvable]primaryBooleanPrimaryboolPrimaryinterface{}#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
validationIResolvable | CfnDataTableAttribute.ValidationPropertyvalidationtyping.Union[IResolvable, ValidationProperty]validationIResolvableValidationIResolvableValidationinterface{}#addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#Parameters
pathpathpathpathPath — The path of the value to delete.addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue — - The value.addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.valuevaluevaluevalueValue — The value.addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
Parameters
strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#Parameters
inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.isCfnDataTableAttribute(x: any): boolean@staticmethod def is_cfn_data_table_attribute(x: Any) -> boolpublic static Boolean isCfnDataTableAttribute(Object x)public static bool IsCfnDataTableAttribute(object x)func IsCfnDataTableAttribute(X interface{}) *boolstatic#isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX — Any object.Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#Parameters
targettargettargettargetTarget — The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.